﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace wsprMsgConv
{
    class Program
    {
        // konvertor z vystupu programu WSPRcode.exe na 
        static void Main(string[] args)
        {
            if (args.GetLength(0) != 1)
            {
                Console.WriteLine("Enter filename of file (output of WSPRcode.exe)");
                return;
            }
            string buf = FillBuffer(args[0]);
            string msg = MsgToBytes(buf);
            Console.Write(msg);
        }

        static string FillBuffer(string filename)
        {
            string data = "";
            bool go = false;
            TextReader tr = new StreamReader(filename);
            string line = tr.ReadLine();
            while (line != null)
            {
                if (line.IndexOf("Channel symbols:") >= 0)
                {
                    go = true;
                    line = tr.ReadLine();
                    continue;
                }
                if (go)
                {
                    if (line.Trim().Length <= 0)
                        go = false;
                    for (int i = 0;i<line.Length;i++)
                    {
                        char x = line[i];
                        if ((x >= '0') && (x <= '3'))
                            data += x;
                    }
                }
                line = tr.ReadLine();
            }
            tr.Close();
            return data;
        }

        static string MsgToBytes(string msg)
        {
            if (msg.Length != 162)
                return null;
            msg += "00";    // set it to 164 bytes
            string bytes = "";
            for (int i = 0; i < 164; i+=4)
            {
                int x = 0;
                for (int j = 0; j < 4; j++)
                {
                    x = x * 4 + (msg[i + j] - '0');
                }
                bytes += "0x" + x.ToString("x") + ", ";
            }
            return bytes;
        }
    }
}
